"""A WSGI app for serving CAS.
"""
from webob import exc, Response
from webob.dec import wsgify


class CASServer(object):
    """A WSGI CAS server.
    """
    @wsgify
    def __call__(self, req):
        if req.path_qs in ['/login', '/validate', '/logout']:
            return getattr(self, req.path_qs[1:])(req)
        return exc.HTTPNotFound()

    def login(self, req):
        return Response('Hi there!')

    def validate(self, req):
        return exc.HTTPNotImplemented()

    def logout(self, req):
        return exc.HTTPNotImplemented()

cas_server = CASServer


def make_cas_server(global_conf, **local_conf):
    return CASServer(**local_conf)
